package by.lsdsl;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.*;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.util.Log;
import android.widget.ScrollView;
import android.widget.TextView;

import java.util.ArrayList;

public class MainActivity extends Activity {


    String SENT = "SMS_SENT_LSDSL";

    TextView textView;
    ScrollView scroll;
    SmsManager sms;
    BroadcastReceiver receiver;

    int all;
    int sent;
    int fault;

    ArrayList<DraftMessage> draftMessages = new ArrayList<DraftMessage>();

//    private RefreshHandler handler = new RefreshHandler();
//
//    class RefreshHandler extends Handler {
//        @Override
//        public void handleMessage(Message msg) {
//            Bundle b = msg.getData();
//            String text = b.getString("text");
//            synchronized (textView) {
//                setTitle(sent + "/" + all);
//                textView.setText(textView.getText().toString() + '\n' + text);
//                scroll.fullScroll(ScrollView.FOCUS_DOWN);
//            }
//        }
//
//
//    }

    /**
     * Called when the activity is first created.
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.main);
        textView = (TextView) findViewById(R.id.log_txt);
        scroll = (ScrollView) findViewById(R.id.scroller);

        sms = SmsManager.getDefault();


        Uri SMSURI = Uri.parse("content://sms/draft");
//        String[] projection = new String[]{"_id", "address", "body", "date"};
        Cursor cursor = null;

//        HashMap<Integer, DraftMessage> draftsAddrMap = null;


        lol("getting drafts sms");

        try {
            cursor = getContentResolver().query(SMSURI
                    , null
                    , null //selection
                    , null //selectionArgs
                    , null); //sortOrder


            if (cursor != null && cursor.moveToFirst()) {
                lol("found " + cursor.getCount() + " draft sms");
//                draftsAddrMap = new HashMap<Integer, DraftMessage>();
                do {
                    int id = cursor.getInt(cursor.getColumnIndex("_id"));
//                    int threadId = cursor.getInt(cursor.getColumnIndex("thread_id"));
                    String address = cursor.getString(cursor.getColumnIndex("address"));
                    String body = cursor.getString(cursor.getColumnIndex("body"));
//                    String date = cursor.getString(cursor.getColumnIndex("date"));

//                    SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy - HH:mm:ss");
//                    date = formatter.format(new Date(Long.parseLong(date)));
//                    getContentResolver().delete(
//                            Uri.parse("content://sms/" + smsId),
//                            null, null);

//                    if (address != null) draftsAddrMap.put(threadId, new DraftMessage(id, address, body));
                    if (address != null && address.length() > 0)
                        draftMessages.add(new DraftMessage(id, address, body));

                    //lol("id: " + id + "  address: " + address + "  body: " + body + "  date: " + date);
                } while (cursor.moveToNext());

                //Log.d("lsdsl", Arrays.toString(cursor.getColumnNames()));
            } else {
                lol("drafts sms not found");
            }
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }


        receiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                lol("onReceive");
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        lol("onReceive RESULT_OK");
                        sent++;
                        lol("1");
                        DraftMessage draftMessage = draftMessages.get(0);
                        lol("SMS sent to " + draftMessage.address);
                        lol("updating message");
                        //type 2 address date
                        ContentValues values = new ContentValues();
                        values.put("type", 2);
//                        values.put("address", draftMessage.address);
                        int update = getContentResolver().update(Uri.parse("content://sms/" + draftMessage.id), values, null, null);
                        lol("update " + update + " sms");
                        draftMessages.remove(0);
                        lol("removed");
                        break;
                    case SmsManager.RESULT_ERROR_GENERIC_FAILURE:
                        lol("Generic failure");
                        draftMessages.add(draftMessages.remove(0));
                        fault++;
                        break;
                    case SmsManager.RESULT_ERROR_NO_SERVICE:
                        lol("No service");
                        draftMessages.add(draftMessages.remove(0));
                        fault++;
                        break;
                    case SmsManager.RESULT_ERROR_NULL_PDU:
                        lol("Null PDU");
                        draftMessages.add(draftMessages.remove(0));
                        fault++;
                        break;
                    case SmsManager.RESULT_ERROR_RADIO_OFF:
                        lol("Radio off");
                        draftMessages.add(draftMessages.remove(0));
                        fault++;
                        break;
                }
                if (fault > 10) {
                    lol("TOO Many faults - STOP");
                    draftMessages.clear();
                }
                sendNextMessage();
            }
        };

        if (draftMessages != null && draftMessages.size() > 0) {
            lol("sending...");
            registerReceiver(receiver, new IntentFilter(SENT));
            all = draftMessages.size();
            sendNextMessage();
        }
    }
//        HashMap<String, DraftMessage> draftsAddrMap = null;
//
//        if (draftsNullMap != null && draftsNullMap.size() > 0) {
//            lol("searching recipients...");
//            draftsAddrMap = new HashMap<String, DraftMessage>();
//
//            try {
//                cursor = getContentResolver().query(Uri.parse("content://sms"), null, null, null, null);
//                if (cursor != null && cursor.moveToFirst()) {
//                    do {
//                        int threadId = cursor.getInt(cursor.getColumnIndex("thread_id"));
//                        int threadId = cursor.getInt(cursor.getColumnIndex("thread_id"));
//                        String address = cursor.getString(cursor.getColumnIndex("address"));
//                        if (draftsNullMap.containsKey(threadId) && !draftsAddrMap.containsKey(address) && address != null) {
//                            DraftMessage value = draftsNullMap.get(threadId);
//                            value.setAddress(address);
//                            draftsAddrMap.put(address, value);
//                            //draftsNullMap.remove(threadId);
//                        }
//
//                    } while (cursor.moveToNext());
//
//                    //Log.d("lsdsl", Arrays.toString(cursor.getColumnNames()));
//                } else {
//                    lol("look like problems with search recipients");
//                }
//            } finally {
//                if (cursor != null) {
//                    cursor.close();
//                }
//            }
//        }


//        }  if (draftsAddrMap != null && draftsAddrMap.size() > 0) {
//            lol("sending...");
//            Set<String> strings = draftsAddrMap.keySet();
//            for (String string : strings) {
//                DraftMessage draftMessage = draftsAddrMap.get(string);
//                if (draftMessage.address != null) {
//                    lol("try send " + draftMessage.body + " to " + string);
//                    sendSimpleSMS(string, draftMessage.body);
//                    lol("sent " + draftMessage.body + " to " + string);
//                    lol("updating message");
//                    //type 2 address date
//                    ContentValues values = new ContentValues();
//                    values.put("type", 2);
//                    values.put("address", draftMessage.address);
//                    int update = getContentResolver().update(Uri.parse("content://sms/" + draftMessage.id), values, null, null);
//                    lol("update " + update + " sms");
//                } else {
//                    lol("skip message " + draftMessage.body + " - not found recipient");
//                }
//
//            }
//        }


//    private void sendSMSIntent(final String phoneNumber, final String message){
//        Uri uri = Uri.parse("smsto:" + phoneNumber);
//        Intent intent = new Intent(Intent.ACTION_SENDTO, uri);
//        intent.putExtra("sms_body", message);
//        startActivity(intent);
//    }


    private void sendSimpleSMS(final String phoneNumber, final String message) {
        SmsManager sms = SmsManager.getDefault();
        sms.sendTextMessage(phoneNumber, null, message, null, null);
    }

    public void sendNextMessage() {
        lol("sendNextMessage()");
        if (draftMessages != null && draftMessages.size() > 0) {
            lol("==============================");
            DraftMessage draftMessage = draftMessages.get(0);
            //draftMessages.remove(0);
            if (draftMessage.address != null) {
                lol("try send " + draftMessage.body + " to " + draftMessage.address);
                sendSMS(draftMessage);
                lol("sent " + draftMessage.body + " to " + draftMessage.address);

            } else {
                lol("skip message " + draftMessage.body + " - not found recipient");
            }
        } else {
            if (receiver != null) unregisterReceiver(receiver);
            lol("==========FINISH==========");
        }
    }


    private void sendSMS(final DraftMessage draftMessage) {

        lol("sendSMS");
//        String DELIVERED = "SMS_DELIVERED";


//        PendingIntent deliveredPI = PendingIntent.getBroadcast(this, 0,
//                new Intent(DELIVERED), 0);
        PendingIntent sentPI = PendingIntent.getBroadcast(this, 0, new Intent(SENT), 0);
        //---when the SMS has been sent---


//        //---when the SMS has been delivered---
//        registerReceiver(new BroadcastReceiver() {
//            @Override
//            public void onReceive(Context arg0, Intent arg1) {
//                switch (getResultCode()) {
//                    case Activity.RESULT_OK:
//                        lol("SMS delivered to " + draftMessage.address);
//                        break;
//                    case Activity.RESULT_CANCELED:
//                        lol("SMS not delivered to " + draftMessage.address);
//                        break;
//                }
//            }
//        }, new IntentFilter(DELIVERED));

        lol("sms manager:" + sms + ":dm=" + draftMessage);

        ArrayList<String> strings = sms.divideMessage(draftMessage.body);
        lol("sms divideMessage to:" + strings.size());
        if (strings.size() > 1) {
            ArrayList<PendingIntent> pendingIntents = new ArrayList<PendingIntent>();
            int size = strings.size();
            for (int i = 0; i < size; i++) {
                if (i == size - 1) pendingIntents.add(sentPI);
                else pendingIntents.add(null);
            }
            sms.sendMultipartTextMessage(draftMessage.address, null, strings, pendingIntents, null);
        } else {
            sms.sendTextMessage(draftMessage.address, null, draftMessage.body, sentPI, null);//deliveredPI);
        }
        lol("sms manager call end");
    }


    private class DraftMessage {
        private int id;
        private String address;
        private String body;

        private DraftMessage(int id, String address, String body) {
            this.id = id;
            this.address = address;
            this.body = body;
        }

        public int getId() {
            return id;
        }

        public void setId(int id) {
            this.id = id;
        }

        public String getAddress() {
            return address;
        }

        public void setAddress(String address) {
            this.address = address;
        }

        public String getBody() {
            return body;
        }

        public void setBody(String body) {
            this.body = body;
        }
    }

    private void lol(final String text) {
//        Message msg = new Message();
//        Bundle data = new Bundle();
//        data.putString("text", text);
//        msg.setData(data);
//        handler.sendMessage(msg);
        Log.d("lsdsl_sms", text == null ? "null" : text);
        setTitle(sent + "/" + all);
        textView.setText(textView.getText().toString() + '\n' + text);
        scroll.fullScroll(ScrollView.FOCUS_DOWN);

    }
}
